
function Out = bil_filter_gray(Im,N,s_d,s_r)
Len = size(Im);
Out = zeros(Len);
% Pre-compute the first gaussian from the formula
[X,Y] = meshgrid(-N:N,-N:N);
Ga = exp(-(X.^2+Y.^2)/(2*s_d^2));
% Bilateral filtering 
for i = 1:Len(1)
        %get the region of interest 
         iMin = max(i-N,1);
         iMax = min(i+N,Len(1));
   for j = 1:Len(2)
         jMin = max(j-N,1);
         jMax = min(j+N,Len(2));
         I = Im(iMin:iMax,jMin:jMax);
         R = I-Im(i,j);
         H = exp(-(R.^2)/(2*s_r^2));
        % Calculate bilateral filter response.
         tmp = H.*Ga((iMin:iMax)-i+N+1,(jMin:jMax)-j+N+1);
         norm_tmp = sum(tmp(:));
         Out(i,j) = sum(sum(tmp.*I))/norm_tmp;
         
   end
end


